// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
using namespace std;

int f1(double* x);
int f2(int* x);
int dswp1(double x, double y);
int dswp2(double* x, double* y);
int f3(int N, double x1, double x2, double* xmin, double* xmax, double* xave);
double f4(double* px1, double* px2, double* px3, double* px4, double* px5);
double f5(double* px1=NULL, double* px2=NULL, double* px3=NULL, double* px4=NULL, double* px5=NULL);
double f6(double* px1, double* px2, double* px3, double* px4, double* px5);

int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
    myofs << "Team 123,   . 18  2008 ." << endl; 
    myofs << "  02-07. ,  " << endl << endl; 
  }
  {    
    myofs << " 1.    double  " << endl;
    double z = 987.654; 
    myofs << "     f1(&z)   z  " << z << endl;
    int m = f1(&z); 
    myofs << "  f1(&z)   z  " << z << endl << endl;
  }
  {    
    myofs << " 2.       ." << endl;
    int n = 4; 
    myofs << "     f2(&n)   n  " << n << endl;
    int m = f2(&n); 
    myofs << "  f2(&n)   n  " << n << endl << endl;
  }
  {    
    myofs << " 3.    swap(double, double)" << endl;
    double x = 123.456, y=987.654; 
    myofs << "         x=" << x << "  y=" << y << endl;
    dswp1(x, y);
    myofs << "  dswp1(x, y), x=" << x << "  y=" << y << endl << endl;
  }
  {    
    myofs << " 4.    swap(double*, double*)" << endl;
    double x = 123.456, y=987.654; 
    myofs << "          x=" << x << "  y=" << y << endl;
    dswp2(&x, &y);
    myofs << "  dswp2(&x, &y) x=" << x << "  y=" << y << endl << endl;
  }
  {    
    myofs << " 5.    " << endl;
    double xa, xb, xc; 
    f3(1000, -3.0, 7.0, &xa, &xb, &xc);
    myofs << " xmin=" << xa << ",  xmax=" << xb << ",  xave=" << xc << endl << endl;
  }
  {    
    myofs << " 6.  NULL" << endl;
    double x1=1.2, x2=2.3, x3=3.4, x4=4.5, x5=5.6; 
    myofs << " f4(&x1,  &x2,  &x3,  &x4,  &x5 )=" << setw(10) << f4(&x1, &x2, &x3, &x4, &x5) << endl;
    myofs << " f4(&x1,  &x2,  &x3,  &x4,  NULL)=" << setw(10) << f4(&x1, &x2, &x3, &x4, NULL) << endl;
    myofs << " f4(&x1,  &x2,  &x3,  NULL, NULL)=" << setw(10) << f4(&x1, &x2, &x3, NULL, NULL) << endl;
    myofs << " f4(&x1,  &x2,  NULL, NULL, NULL)=" << setw(10) << f4(&x1, &x2, NULL, NULL, NULL) << endl;
    myofs << " f4(&x1,  NULL, NULL, NULL, NULL)=" << setw(10) << f4(&x1, NULL, NULL, NULL, NULL) << endl;
    myofs << " f4(NULL, NULL, NULL, NULL, NULL)=" << setw(10) << f4(NULL, NULL, NULL, NULL, NULL) << endl;
    myofs << " NULL=" << NULL << endl;
  }
  {    
    myofs << " 7.    " << endl;
    myofs << "              (   )" << endl;
    double x1=1.2, x2=2.3, x3=3.4, x4=4.5, x5=5.6; 
    myofs << " f5(&x1,  &x2,  &x3,  &x4,  &x5 )=" << setw(10) << f5(&x1, &x2, &x3, &x4, &x5) << endl;
    myofs << " f5(&x1,  &x2,  &x3,  &x4)=       " << setw(10) << f5(&x1, &x2, &x3, &x4, NULL) << endl;
    myofs << " f5(&x1,  &x2,  &x3)=             " << setw(10) << f5(&x1, &x2, &x3, NULL, NULL) << endl;
    myofs << " f5(&x1,  &x2)=                   " << setw(10) << f5(&x1, &x2, NULL, NULL, NULL) << endl;
    myofs << " f5(&x1)=                         " << setw(10) << f5(&x1, NULL, NULL, NULL, NULL) << endl;
    myofs << " f5()=                            " << setw(10) << f5(NULL, NULL, NULL, NULL, NULL) << endl;
  }
  {    
    myofs << " 8.    " << endl;
    myofs << "              (     )" << endl;
    double x1=1.2, x2=2.3, x3=3.4, x4=4.5, x5=5.6; 
    myofs << " f6(&x1,  &x2,  &x3,  &x4,  &x5 )=" << setw(10) << f6(&x1, &x2, &x3, &x4, &x5) << endl;
    myofs << " f6(&x1,  &x2,  &x3,  &x4)=       " << setw(10) << f6(&x1, &x2, &x3, &x4, NULL) << endl;
    myofs << " f6(&x1,  &x2,  &x3)=             " << setw(10) << f6(&x1, &x2, &x3, NULL, NULL) << endl;
    myofs << " f6(&x1,  &x2)=                   " << setw(10) << f6(&x1, &x2, NULL, NULL, NULL) << endl;
    myofs << " f6(&x1)=                         " << setw(10) << f6(&x1, NULL, NULL, NULL, NULL) << endl;
    myofs << " f6()=                            " << setw(10) << f6(NULL, NULL, NULL, NULL, NULL) << endl;
  }
   myofs.close();
  return 0;
}

int f1(double* x){ 
  *x = 123.567;
  return 1; 
}
int f2(int* x){ 
  *x = 456;
  return 1; 
}
int dswp1(double x, double y){
  double z=x;
  x=y;
  y=z; 
  return 1;
} 
int dswp2(double* x, double* y){
  double z=*x;
  *x=*y;
  *y=z; return 1;
} 
int f3(int N, double x1, double x2, double* xmin, double* xmax, double* xave){
  double xa, xb, xc, x;
  int count=0;
  for(int n=0; n<N; n++){
    count++;
    x=x1+double(rand()%1024)*(x2-x1)/1024.0;
    if(n==0){
      xa=x;
      xb=x;
      xc=x;
      continue;
    }
    if(x<xa)xa=x;
    if(x>xb)xb=x;
    xc += x;
  }
  *xmin = xa;
  *xmax = xb;
  *xave = xc/double(count); 
  return 1;
} 
double f4(double* px1, double* px2, double* px3, double* px4, double* px5){
  double x=0.0;
  if(px1) x += *px1;
  if(px2) x += *px2;
  if(px3) x += *px3;
  if(px4) x += *px4;
  if(px5) x += *px5;
  return x;
}
double f5(double* px1, double* px2, double* px3, double* px4, double* px5){
  double x=0.0;
  if(px1) x += *px1;
  if(px2) x += *px2;
  if(px3) x += *px3;
  if(px4) x += *px4;
  if(px5) x += *px5;
  return x;
}
double f6(double* px1=NULL, double* px2=NULL, double* px3=NULL, double* px4=NULL, double* px5=NULL){
  double x=0.0;
  if(px1) x += *px1;
  if(px2) x += *px2;
  if(px3) x += *px3;
  if(px4) x += *px4;
  if(px5) x += *px5;
  return x;
}